function GetOciTopLevelCommand_cloud_guard() {
    return 'cloud-guard'
}

function GetOciSubcommands_cloud_guard() {
    $ociSubcommands = @{
        'cloud-guard' = 'activity-problem-aggregation condition-metadata-type configuration data-mask-rule detector detector-recipe detector-recipe-detector-rule detector-rule impacted-resource-summary managed-list managed-list-type-summary policy-summary problem problem-aggregation problem-trend-aggregation recommendation-summary resource-type-summary responder-activity-summary responder-execution responder-execution-aggregation responder-execution-summary responder-execution-trend-aggregation responder-recipe responder-recipe-responder-rule responder-rule risk-score-aggregation security-score-aggregation security-score-trend-aggregation target target-detector-recipe target-detector-recipe-detector-rule target-responder-recipe target-responder-recipe-responder-rule'
        'cloud-guard activity-problem-aggregation' = 'request-summarized-activity-problems'
        'cloud-guard condition-metadata-type' = 'get list'
        'cloud-guard configuration' = 'get update'
        'cloud-guard data-mask-rule' = 'create create-for-all-targets create-for-services create-for-targets delete get list update update-for-all-targets update-for-services update-for-targets'
        'cloud-guard detector' = 'get list'
        'cloud-guard detector-recipe' = 'change-compartment create delete get list update'
        'cloud-guard detector-recipe-detector-rule' = 'get list update'
        'cloud-guard detector-rule' = 'get list'
        'cloud-guard impacted-resource-summary' = 'list-impacted-resources'
        'cloud-guard managed-list' = 'change-compartment create delete get list update'
        'cloud-guard managed-list-type-summary' = 'list-managed-list-types'
        'cloud-guard policy-summary' = 'list-policies'
        'cloud-guard problem' = 'get list list-problem-histories trigger-responder update-bulk-problem-status update-problem-status'
        'cloud-guard problem-aggregation' = 'request-summarized-problems'
        'cloud-guard problem-trend-aggregation' = 'request-summarized-trend-problems'
        'cloud-guard recommendation-summary' = 'list-recommendations'
        'cloud-guard resource-type-summary' = 'list-resource-types'
        'cloud-guard responder-activity-summary' = 'list-responder-activities'
        'cloud-guard responder-execution' = 'execute get skip skip-bulk'
        'cloud-guard responder-execution-aggregation' = 'request-summarized-responder-executions'
        'cloud-guard responder-execution-summary' = 'list-responder-executions'
        'cloud-guard responder-execution-trend-aggregation' = 'request-summarized-trend-responder-executions'
        'cloud-guard responder-recipe' = 'change-compartment create delete get list update'
        'cloud-guard responder-recipe-responder-rule' = 'get list update'
        'cloud-guard responder-rule' = 'get list'
        'cloud-guard risk-score-aggregation' = 'request-risk-scores request-summarized-risk-scores'
        'cloud-guard security-score-aggregation' = 'request-security-scores request-summarized-security-scores'
        'cloud-guard security-score-trend-aggregation' = 'request-security-score-summarized-trend request-summarized-trend-security-scores'
        'cloud-guard target' = 'create delete get list update'
        'cloud-guard target-detector-recipe' = 'create delete get list update'
        'cloud-guard target-detector-recipe-detector-rule' = 'get list update'
        'cloud-guard target-responder-recipe' = 'create delete get list update'
        'cloud-guard target-responder-recipe-responder-rule' = 'get list update'
    }
    return $ociSubcommands
}

function GetOciCommandsToLongParams_cloud_guard() {
    $ociCommandsToLongParams = @{
        'cloud-guard activity-problem-aggregation request-summarized-activity-problems' = 'access-level compartment-id compartment-id-in-subtree from-json help include-unknown-locations limit page'
        'cloud-guard condition-metadata-type get' = 'condition-metadata-type-id from-json help resource-type service-type'
        'cloud-guard condition-metadata-type list' = 'all compartment-id from-json help lifecycle-state limit page page-size sort-by sort-order'
        'cloud-guard configuration get' = 'compartment-id from-json help'
        'cloud-guard configuration update' = 'compartment-id from-json help if-match reporting-region self-manage-resources status'
        'cloud-guard data-mask-rule create' = 'compartment-id data-mask-categories data-mask-rule-status defined-tags description display-name freeform-tags from-json help iam-group-id lifecycle-state max-wait-seconds target-selected wait-for-state wait-interval-seconds'
        'cloud-guard data-mask-rule create-for-all-targets' = 'compartment-id data-mask-categories data-mask-rule-status defined-tags description display-name freeform-tags from-json help iam-group-id lifecycle-state max-wait-seconds wait-for-state wait-interval-seconds'
        'cloud-guard data-mask-rule create-for-services' = 'compartment-id data-mask-categories data-mask-rule-status defined-tags description display-name freeform-tags from-json help iam-group-id lifecycle-state max-wait-seconds target-selected-values wait-for-state wait-interval-seconds'
        'cloud-guard data-mask-rule create-for-targets' = 'compartment-id data-mask-categories data-mask-rule-status defined-tags description display-name freeform-tags from-json help iam-group-id lifecycle-state max-wait-seconds target-selected-values wait-for-state wait-interval-seconds'
        'cloud-guard data-mask-rule delete' = 'data-mask-rule-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'cloud-guard data-mask-rule get' = 'data-mask-rule-id from-json help'
        'cloud-guard data-mask-rule list' = 'access-level all compartment-id data-mask-rule-status display-name from-json help iam-group-id lifecycle-state limit page page-size sort-by sort-order target-id target-type'
        'cloud-guard data-mask-rule update' = 'compartment-id data-mask-categories data-mask-rule-id data-mask-rule-status defined-tags display-name force freeform-tags from-json help iam-group-id if-match max-wait-seconds target-selected wait-for-state wait-interval-seconds'
        'cloud-guard data-mask-rule update-for-all-targets' = 'compartment-id data-mask-categories data-mask-rule-id data-mask-rule-status defined-tags display-name force freeform-tags from-json help iam-group-id if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'cloud-guard data-mask-rule update-for-services' = 'compartment-id data-mask-categories data-mask-rule-id data-mask-rule-status defined-tags display-name force freeform-tags from-json help iam-group-id if-match max-wait-seconds target-selected-values wait-for-state wait-interval-seconds'
        'cloud-guard data-mask-rule update-for-targets' = 'compartment-id data-mask-categories data-mask-rule-id data-mask-rule-status defined-tags display-name force freeform-tags from-json help iam-group-id if-match max-wait-seconds target-selected-values wait-for-state wait-interval-seconds'
        'cloud-guard detector get' = 'detector-id from-json help'
        'cloud-guard detector list' = 'all compartment-id from-json help lifecycle-state limit page page-size sort-by sort-order'
        'cloud-guard detector-recipe change-compartment' = 'compartment-id detector-recipe-id from-json help if-match'
        'cloud-guard detector-recipe create' = 'compartment-id defined-tags description detector-rules display-name freeform-tags from-json help max-wait-seconds source-detector-recipe-id wait-for-state wait-interval-seconds'
        'cloud-guard detector-recipe delete' = 'detector-recipe-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'cloud-guard detector-recipe get' = 'detector-recipe-id from-json help'
        'cloud-guard detector-recipe list' = 'access-level all compartment-id compartment-id-in-subtree display-name from-json help lifecycle-state limit page page-size resource-metadata-only sort-by sort-order'
        'cloud-guard detector-recipe update' = 'defined-tags description detector-recipe-id detector-rules display-name force freeform-tags from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'cloud-guard detector-recipe-detector-rule get' = 'detector-recipe-id detector-rule-id from-json help'
        'cloud-guard detector-recipe-detector-rule list' = 'all compartment-id detector-recipe-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order'
        'cloud-guard detector-recipe-detector-rule update' = 'details detector-recipe-id detector-rule-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'cloud-guard detector-rule get' = 'detector-id detector-rule-id from-json help'
        'cloud-guard detector-rule list' = 'all compartment-id detector-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order'
        'cloud-guard impacted-resource-summary list-impacted-resources' = 'all from-json help limit page page-size problem-id sort-by sort-order'
        'cloud-guard managed-list change-compartment' = 'compartment-id from-json help if-match managed-list-id'
        'cloud-guard managed-list create' = 'compartment-id defined-tags description display-name freeform-tags from-json help list-items list-type max-wait-seconds source-managed-list-id wait-for-state wait-interval-seconds'
        'cloud-guard managed-list delete' = 'force from-json help if-match managed-list-id max-wait-seconds wait-for-state wait-interval-seconds'
        'cloud-guard managed-list get' = 'from-json help managed-list-id'
        'cloud-guard managed-list list' = 'access-level all compartment-id compartment-id-in-subtree display-name from-json help lifecycle-state limit list-type page page-size resource-metadata-only sort-by sort-order'
        'cloud-guard managed-list update' = 'defined-tags description display-name force freeform-tags from-json help if-match list-items managed-list-id max-wait-seconds wait-for-state wait-interval-seconds'
        'cloud-guard managed-list-type-summary list-managed-list-types' = 'all compartment-id from-json help lifecycle-state limit page page-size sort-by sort-order'
        'cloud-guard policy-summary list-policies' = 'all compartment-id from-json help limit page page-size sort-by sort-order'
        'cloud-guard problem get' = 'from-json help problem-id'
        'cloud-guard problem list' = 'access-level all city compartment-id compartment-id-in-subtree country detector-rule-id-list detector-type from-json help label lifecycle-detail lifecycle-state limit page page-size problem-region resource-id resource-type risk-level sort-by sort-order state target-id time-first-detected-greater-than-or-equal-to time-first-detected-less-than-or-equal-to time-last-detected-greater-than-or-equal-to time-last-detected-less-than-or-equal-to'
        'cloud-guard problem list-problem-histories' = 'all compartment-id from-json help limit page page-size problem-id sort-by sort-order'
        'cloud-guard problem trigger-responder' = 'configurations from-json help if-match problem-id responder-rule-id'
        'cloud-guard problem update-bulk-problem-status' = 'comment from-json help problem-ids status'
        'cloud-guard problem update-problem-status' = 'comment from-json help if-match max-wait-seconds problem-id status wait-for-state wait-interval-seconds'
        'cloud-guard problem-aggregation request-summarized-problems' = 'access-level compartment-id compartment-id-in-subtree from-json help limit list-dimensions page'
        'cloud-guard problem-trend-aggregation request-summarized-trend-problems' = 'access-level compartment-id compartment-id-in-subtree from-json help limit page time-first-detected-greater-than-or-equal-to time-first-detected-less-than-or-equal-to'
        'cloud-guard recommendation-summary list-recommendations' = 'access-level all compartment-id compartment-id-in-subtree from-json help lifecycle-detail lifecycle-state limit page page-size sort-by sort-order target-id'
        'cloud-guard resource-type-summary list-resource-types' = 'all compartment-id from-json help lifecycle-state limit page page-size sort-by sort-order'
        'cloud-guard responder-activity-summary list-responder-activities' = 'all from-json help limit page page-size problem-id sort-by sort-order'
        'cloud-guard responder-execution execute' = 'compartment-id configurations from-json help if-match responder-execution-id'
        'cloud-guard responder-execution get' = 'from-json help responder-execution-id'
        'cloud-guard responder-execution skip' = 'compartment-id from-json help if-match responder-execution-id'
        'cloud-guard responder-execution skip-bulk' = 'from-json help responder-execution-ids'
        'cloud-guard responder-execution-aggregation request-summarized-responder-executions' = 'access-level compartment-id compartment-id-in-subtree from-json help limit page responder-execution-status-filter responder-executions-dimensions responder-type-filter'
        'cloud-guard responder-execution-summary list-responder-executions' = 'access-level all compartment-id compartment-id-in-subtree from-json help limit page page-size resource-type responder-execution-mode responder-execution-status responder-rule-ids responder-type sort-by sort-order target-id time-completed-greater-than-or-equal-to time-completed-less-than-or-equal-to time-created-greater-than-or-equal-to time-created-less-than-or-equal-to'
        'cloud-guard responder-execution-trend-aggregation request-summarized-trend-responder-executions' = 'access-level compartment-id compartment-id-in-subtree from-json help limit page time-completed-greater-than-or-equal-to time-completed-less-than-or-equal-to'
        'cloud-guard responder-recipe change-compartment' = 'compartment-id from-json help if-match responder-recipe-id'
        'cloud-guard responder-recipe create' = 'compartment-id defined-tags description display-name freeform-tags from-json help max-wait-seconds responder-rules source-responder-recipe-id wait-for-state wait-interval-seconds'
        'cloud-guard responder-recipe delete' = 'force from-json help if-match max-wait-seconds responder-recipe-id wait-for-state wait-interval-seconds'
        'cloud-guard responder-recipe get' = 'from-json help responder-recipe-id'
        'cloud-guard responder-recipe list' = 'access-level all compartment-id compartment-id-in-subtree display-name from-json help lifecycle-state limit page page-size resource-metadata-only sort-by sort-order'
        'cloud-guard responder-recipe update' = 'defined-tags description display-name force freeform-tags from-json help if-match max-wait-seconds responder-recipe-id responder-rules wait-for-state wait-interval-seconds'
        'cloud-guard responder-recipe-responder-rule get' = 'from-json help responder-recipe-id responder-rule-id'
        'cloud-guard responder-recipe-responder-rule list' = 'all compartment-id display-name from-json help lifecycle-state limit page page-size responder-recipe-id sort-by sort-order'
        'cloud-guard responder-recipe-responder-rule update' = 'details force from-json help if-match max-wait-seconds responder-recipe-id responder-rule-id wait-for-state wait-interval-seconds'
        'cloud-guard responder-rule get' = 'from-json help responder-rule-id'
        'cloud-guard responder-rule list' = 'all compartment-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order'
        'cloud-guard risk-score-aggregation request-risk-scores' = 'compartment-id from-json help limit page'
        'cloud-guard risk-score-aggregation request-summarized-risk-scores' = 'compartment-id from-json help limit page'
        'cloud-guard security-score-aggregation request-security-scores' = 'compartment-id from-json help limit page'
        'cloud-guard security-score-aggregation request-summarized-security-scores' = 'compartment-id from-json help limit page'
        'cloud-guard security-score-trend-aggregation request-security-score-summarized-trend' = 'compartment-id from-json help limit page time-score-computed-greater-than-or-equal-to time-score-computed-less-than-or-equal-to'
        'cloud-guard security-score-trend-aggregation request-summarized-trend-security-scores' = 'compartment-id from-json help limit page time-score-computed-greater-than-or-equal-to time-score-computed-less-than-or-equal-to'
        'cloud-guard target create' = 'compartment-id defined-tags description display-name freeform-tags from-json help lifecycle-state max-wait-seconds target-detector-recipes target-resource-id target-resource-type target-responder-recipes wait-for-state wait-interval-seconds'
        'cloud-guard target delete' = 'force from-json help if-match max-wait-seconds target-id wait-for-state wait-interval-seconds'
        'cloud-guard target get' = 'from-json help target-id'
        'cloud-guard target list' = 'access-level all compartment-id compartment-id-in-subtree display-name from-json help lifecycle-state limit page page-size sort-by sort-order'
        'cloud-guard target update' = 'defined-tags display-name force freeform-tags from-json help if-match lifecycle-state max-wait-seconds target-detector-recipes target-id target-responder-recipes wait-for-state wait-interval-seconds'
        'cloud-guard target-detector-recipe create' = 'detector-recipe-id from-json help max-wait-seconds target-id wait-for-state wait-interval-seconds'
        'cloud-guard target-detector-recipe delete' = 'force from-json help if-match target-detector-recipe-id target-id'
        'cloud-guard target-detector-recipe get' = 'from-json help target-detector-recipe-id target-id'
        'cloud-guard target-detector-recipe list' = 'all compartment-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order target-id'
        'cloud-guard target-detector-recipe update' = 'detector-rules force from-json help if-match max-wait-seconds target-detector-recipe-id target-id wait-for-state wait-interval-seconds'
        'cloud-guard target-detector-recipe-detector-rule get' = 'detector-rule-id from-json help target-detector-recipe-id target-id'
        'cloud-guard target-detector-recipe-detector-rule list' = 'all compartment-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order target-detector-recipe-id target-id'
        'cloud-guard target-detector-recipe-detector-rule update' = 'details detector-rule-id force from-json help if-match max-wait-seconds target-detector-recipe-id target-id wait-for-state wait-interval-seconds'
        'cloud-guard target-responder-recipe create' = 'from-json help responder-recipe-id target-id'
        'cloud-guard target-responder-recipe delete' = 'force from-json help if-match target-id target-responder-recipe-id'
        'cloud-guard target-responder-recipe get' = 'from-json help target-id target-responder-recipe-id'
        'cloud-guard target-responder-recipe list' = 'all compartment-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order target-id'
        'cloud-guard target-responder-recipe update' = 'force from-json help if-match responder-rules target-id target-responder-recipe-id'
        'cloud-guard target-responder-recipe-responder-rule get' = 'from-json help responder-rule-id target-id target-responder-recipe-id'
        'cloud-guard target-responder-recipe-responder-rule list' = 'all compartment-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order target-id target-responder-recipe-id'
        'cloud-guard target-responder-recipe-responder-rule update' = 'details force from-json help if-match max-wait-seconds responder-rule-id target-id target-responder-recipe-id wait-for-state wait-interval-seconds'
    }
    return $ociCommandsToLongParams
}

function GetOciCommandsToShortParams_cloud_guard() {
    $ociCommandsToShortParams = @{
        'cloud-guard activity-problem-aggregation request-summarized-activity-problems' = '? c h'
        'cloud-guard condition-metadata-type get' = '? h'
        'cloud-guard condition-metadata-type list' = '? c h'
        'cloud-guard configuration get' = '? c h'
        'cloud-guard configuration update' = '? c h'
        'cloud-guard data-mask-rule create' = '? c h'
        'cloud-guard data-mask-rule create-for-all-targets' = '? c h'
        'cloud-guard data-mask-rule create-for-services' = '? c h'
        'cloud-guard data-mask-rule create-for-targets' = '? c h'
        'cloud-guard data-mask-rule delete' = '? h'
        'cloud-guard data-mask-rule get' = '? h'
        'cloud-guard data-mask-rule list' = '? c h'
        'cloud-guard data-mask-rule update' = '? c h'
        'cloud-guard data-mask-rule update-for-all-targets' = '? c h'
        'cloud-guard data-mask-rule update-for-services' = '? c h'
        'cloud-guard data-mask-rule update-for-targets' = '? c h'
        'cloud-guard detector get' = '? h'
        'cloud-guard detector list' = '? c h'
        'cloud-guard detector-recipe change-compartment' = '? c h'
        'cloud-guard detector-recipe create' = '? c h'
        'cloud-guard detector-recipe delete' = '? h'
        'cloud-guard detector-recipe get' = '? h'
        'cloud-guard detector-recipe list' = '? c h'
        'cloud-guard detector-recipe update' = '? h'
        'cloud-guard detector-recipe-detector-rule get' = '? h'
        'cloud-guard detector-recipe-detector-rule list' = '? c h'
        'cloud-guard detector-recipe-detector-rule update' = '? h'
        'cloud-guard detector-rule get' = '? h'
        'cloud-guard detector-rule list' = '? c h'
        'cloud-guard impacted-resource-summary list-impacted-resources' = '? h'
        'cloud-guard managed-list change-compartment' = '? c h'
        'cloud-guard managed-list create' = '? c h'
        'cloud-guard managed-list delete' = '? h'
        'cloud-guard managed-list get' = '? h'
        'cloud-guard managed-list list' = '? c h'
        'cloud-guard managed-list update' = '? h'
        'cloud-guard managed-list-type-summary list-managed-list-types' = '? c h'
        'cloud-guard policy-summary list-policies' = '? c h'
        'cloud-guard problem get' = '? h'
        'cloud-guard problem list' = '? c h'
        'cloud-guard problem list-problem-histories' = '? c h'
        'cloud-guard problem trigger-responder' = '? h'
        'cloud-guard problem update-bulk-problem-status' = '? h'
        'cloud-guard problem update-problem-status' = '? h'
        'cloud-guard problem-aggregation request-summarized-problems' = '? c h'
        'cloud-guard problem-trend-aggregation request-summarized-trend-problems' = '? c h'
        'cloud-guard recommendation-summary list-recommendations' = '? c h'
        'cloud-guard resource-type-summary list-resource-types' = '? c h'
        'cloud-guard responder-activity-summary list-responder-activities' = '? h'
        'cloud-guard responder-execution execute' = '? c h'
        'cloud-guard responder-execution get' = '? h'
        'cloud-guard responder-execution skip' = '? c h'
        'cloud-guard responder-execution skip-bulk' = '? h'
        'cloud-guard responder-execution-aggregation request-summarized-responder-executions' = '? c h'
        'cloud-guard responder-execution-summary list-responder-executions' = '? c h'
        'cloud-guard responder-execution-trend-aggregation request-summarized-trend-responder-executions' = '? c h'
        'cloud-guard responder-recipe change-compartment' = '? c h'
        'cloud-guard responder-recipe create' = '? c h'
        'cloud-guard responder-recipe delete' = '? h'
        'cloud-guard responder-recipe get' = '? h'
        'cloud-guard responder-recipe list' = '? c h'
        'cloud-guard responder-recipe update' = '? h'
        'cloud-guard responder-recipe-responder-rule get' = '? h'
        'cloud-guard responder-recipe-responder-rule list' = '? c h'
        'cloud-guard responder-recipe-responder-rule update' = '? h'
        'cloud-guard responder-rule get' = '? h'
        'cloud-guard responder-rule list' = '? c h'
        'cloud-guard risk-score-aggregation request-risk-scores' = '? c h'
        'cloud-guard risk-score-aggregation request-summarized-risk-scores' = '? c h'
        'cloud-guard security-score-aggregation request-security-scores' = '? c h'
        'cloud-guard security-score-aggregation request-summarized-security-scores' = '? c h'
        'cloud-guard security-score-trend-aggregation request-security-score-summarized-trend' = '? c h'
        'cloud-guard security-score-trend-aggregation request-summarized-trend-security-scores' = '? c h'
        'cloud-guard target create' = '? c h'
        'cloud-guard target delete' = '? h'
        'cloud-guard target get' = '? h'
        'cloud-guard target list' = '? c h'
        'cloud-guard target update' = '? h'
        'cloud-guard target-detector-recipe create' = '? h'
        'cloud-guard target-detector-recipe delete' = '? h'
        'cloud-guard target-detector-recipe get' = '? h'
        'cloud-guard target-detector-recipe list' = '? c h'
        'cloud-guard target-detector-recipe update' = '? h'
        'cloud-guard target-detector-recipe-detector-rule get' = '? h'
        'cloud-guard target-detector-recipe-detector-rule list' = '? c h'
        'cloud-guard target-detector-recipe-detector-rule update' = '? h'
        'cloud-guard target-responder-recipe create' = '? h'
        'cloud-guard target-responder-recipe delete' = '? h'
        'cloud-guard target-responder-recipe get' = '? h'
        'cloud-guard target-responder-recipe list' = '? c h'
        'cloud-guard target-responder-recipe update' = '? h'
        'cloud-guard target-responder-recipe-responder-rule get' = '? h'
        'cloud-guard target-responder-recipe-responder-rule list' = '? c h'
        'cloud-guard target-responder-recipe-responder-rule update' = '? h'
    }
    return $ociCommandsToShortParams
}